#!/usr/bin/env python 
#				 -*- coding: utf-8 -*-
#
# Un module pour simplifier la vie des étudiants en Cip2.
#
#           Author: Erick Gallesio [eg@unice.fr]
#    Creation date: 10-Sep-2009 11:01 (eg)
# Last file update: 16-Oct-2010 21:26 (eg)

save_open=open

# import sys, os, glob;
from sys     import *;
from os      import *;
from os.path import *;
from glob    import *;
from time    import *;
import re;

# ----------------------------------------------------------------------
# fatal_error
# ----------------------------------------------------------------------
def fatal_error(msg) :
   stderr.write(msg + '\n');
   exit(1);

# ----------------------------------------------------------------------
# shell: shell("ls") ==> ['a', 'b', ...]
#----------------------------------------------------------------------
import subprocess;

def shell(str):
    res  = [] 
    proc = subprocess.Popen(str, shell=True, stdout=subprocess.PIPE)

    for line in  proc.stdout :
        res.append(line[:-1]);
    return res


# ----------------------------------------------------------------------
# get_options: retourne les options et les paramètres de argv
#    >>> o,p=get_options('foo --foo=bar --gee a b c'.split())
#    >>> o
#    [['--foo', 'bar'], ['--gee', '']]
#    >>> p
#    ['a', 'b', 'c']
#----------------------------------------------------------------------
def get_options(argv):
    o =[];
    i = 1;
    for opt in argv[1:] :
        if not opt[0] == '-' :
            break
        res = opt.split('=');
        if len(res) == 1: 
            res.append('');
        o.append(res);
        i += 1;
    return o, argv[i:]

# ----------------------------------------------------------------------
# Un printf à la C pour ne pas montrer l'opérateur "%" 
# qui perturbe les étudiants (mais pourquoi donc) 
# ----------------------------------------------------------------------
def printf(format, *args): 
   stdout.write(str(format) % args)


# ----------------------------------------------------------------------
# La classe Server qui permet de construire un serveur sans connaitre 
# les arcanes des sockets 
# ----------------------------------------------------------------------
import socket

class Server:
    '''
    Classe décrivant un Serveur TCP.  

    La version qui est donnée ici ne pourrait pas marcher dans un
    environnement multi-threads, ce qui est largement au dessus de ce
    dont on a besoin pour le cours de CiP2
    '''
    
    def __init__(self, port = 1234, verbose = False):
        c = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        c.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1) 
        c.bind(("localhost", port))
        c.listen(5)
        self.connection = c
        self.port       = port
        self.verbose    = verbose

    def accept_connection(self):
        if (self.verbose):
            print("-----------------------------------")
            print("Serveur en attente connexion sur le port %d" % self.port)

        # Let the wizard play
        csock, caddr = self.connection.accept()
        cfile = csock.makefile('rw', 0)
        self.csock = csock
        self.caddr = caddr
        self.cfile = cfile
        
        if (self.verbose):
            print("  Connexion client depuis la machine %s" % str(caddr))
        return cfile
    
    def readline(self):
       line = self.cfile.readline().strip()
       if (self.verbose):
          print("    <== %s" % line)
       return line
       
    def writeline(self, string):
       if (self.verbose):
          print("    ==> %s" % string)
       self.cfile.write(string)

    def close(self):
       if (self.verbose):
          print("  Fermeture de la connexion avec %s" % str(self.caddr))
       self.cfile.flush()
       self.cfile.close()
       self.csock.shutdown(socket.SHUT_RDWR)

      
#######################################################################

# Open est écrasé par notre manip. On corrige
open=save_open

# renommmer re.sub
regsub = re.sub

#
# Juste au cas où
#
if __name__ == "__main__" :
    fatal_error('Il faut faire "from cip import *" et non pas exécuter ce fichier');
    exit(1);
