from cip import *
from imgcip import *
from math import *

#################################################################################################
#######  INITIALISATION DES VARIABLES

options, arguments=get_options(argv)

old=""
new=""


for case in options:
	if case[0]=="--old":
		old=case[1]
	if case[0]=="--new":
		new=case[1]

table=[['blanc' '255 255 255'],		# Tableau de correspondance   Couleur <=> Code RGB
	['noir', '0 0 0'],
	['gris', '128 128 128'],
	['bleu', '0 0 255'],
	['rouge', '255 0 0'],
	['jaune', '255 255 0'],
	['rose', '255 0 255'],
	['vert', '0 255 0']]
	


##################################################################################################
#######  FONCTIONS DE CONVERSION

# Fonction qui transforme un code couleur rgb en liste:   "255 128 0" => [255, 128, 0]
def rgb_to_list(rgb):
	liste=[int(rgb.split(" ")[0]),int(rgb.split(" ")[1]),int(rgb.split(" ")[2])]
	return liste

# Fonction qui transforme une liste en code couleur rgb:   [255, 128, 0] => "255 128 0"
def list_to_rgb(liste):
	rgb=str(liste[0])+' '+str(liste[1])+' '+str(liste[2])
	return rgb

# Fonction qui convertit chaque pixel en code couleur rgb:    {Pix 255,128,0} => "255 128 0"
def pixel_to_rgb(pix):
	rgb=str(pix.R)+' '+str(pix.G)+' '+str(pix.B)
	return rgb
	
	
##################################################################################################
#######  FONCTION DE RETOUCHE

def old_to_new(old, new, color):
	for case in table:
		if case[0]==old:
			old=case[1]
		if case[0]==new:
			new=case[1]
	old_list=rgb_to_list(old)
	color_list=rgb_to_list(color)
	distance=sqrt(pow(int(old_list[0]) - int(color_list[0]),2)+pow(int(old_list[1]) - int(color_list[1]),2)+pow(int(old_list[2]) - int(color_list[2]),2))
	# Si le pixel analyse est proche de la couleur que l'on souhaite changer, on change sa valeur pour mettre la nouvelle couleur
	if distance <= 200:
		return new
	else:			# Sinon, on laisse la valeur initiale
		return color

##################################################################################################
#######  FONCTION D'ENREGISTREMENT DE FICHIER

def save_image(image, fichier):
	f=open(fichier, 'w')
	f.write('P3\n'+str(image.width)+' '+str(image.height)+' '+str(image.depth)+'\n')
	for i in image.pixels:
		rgb=pixel_to_rgb(i)
		rgb=old_to_new(old, new, rgb)
		f.write(rgb+'\n')
	f.close()


##################################################################################################
#######  DEBUT DU PROGRAMME

img=read_image(arguments[0])

save_image(img, arguments[1])

# Exemple sur le terminal:
# ~$ python exo2.1.py --old="bleu" --new="vert" saloon.ppm saloon2.ppm
