from cip import *
from imgcip import *
from math import *


##################################################################################################
#######  FONCTIONS DE CONVERSION

# Fonction qui transforme un code couleur rgb en liste:   "255 128 0" => [255, 128, 0]
def rgb_to_list(rgb):
	liste=[int(rgb.split(" ")[0]),int(rgb.split(" ")[1]),int(rgb.split(" ")[2])]
	return liste

# Fonction qui transforme une liste en code couleur rgb:   [255, 128, 0] => "255 128 0"
def list_to_rgb(liste):
	rgb=str(liste[0])+' '+str(liste[1])+' '+str(liste[2])
	return rgb

# Fonction qui convertit chaque pixel en code couleur rgb:    {Pix 255,128,0} => "255 128 0"
def pixel_to_rgb(pix):
	rgb=str(pix.R)+' '+str(pix.G)+' '+str(pix.B)
	return rgb
	
	
##################################################################################################
#######  FONCTION DE RETOUCHE

def negatif(color):
	color_list=rgb_to_list(color)
	color_list=[255-int(color_list[0]),255-int(color_list[1]),255-int(color_list[2])] # Par exemple, "0 1 2" => "255 254 253"
	return list_to_rgb(color_list)
	

##################################################################################################
#######  FONCTION D'ENREGISTREMENT DU FICHIER

def save_image(image, fichier):
	f=open(fichier, 'w')
	f.write('P3\n'+str(image.width)+' '+str(image.height)+' '+str(image.depth)+'\n')
	for i in image.pixels:
		rgb=pixel_to_rgb(i)
		rgb=negatif(rgb)		#On converti chaque pixel en pixel aux couleurs inverses
		f.write(rgb+'\n')
	f.close()

##################################################################################################
#######  DEBUT DU PROGRAMME

options, arguments=get_options(argv)
img=read_image(arguments[0])

save_image(img, arguments[1])

# Exemple sur le terminal:
# ~$ python exo2.2.py Oeuvre_d_art.ppm Oeuvre_d_art_negatif.ppm
