from cip import *
from imgcip import *
from math import *

#################################################################################################
#######  INITIALISATION DES VARIABLES

options, arguments=get_options(argv)

old=""
new=""
for case in options:
	if case[0]=="--old":
		old=case[1]
	if case[0]=="--new":
		new=case[1]

table=[['blanc' '255 255 255'],
	['noir', '0 0 0'],
	['gris', '128 128 128'],
	['bleu', '0 0 255'],
	['rouge', '255 0 0'],
	['jaune', '255 255 0'],
	['rose', '255 0 255'],
	['vert', '0 255 0']]

##################################################################################################
#######  FONCTIONS DE CONVERSION

def rgb_to_list(rgb):
	liste=[int(rgb.split(" ")[0]),int(rgb.split(" ")[1]),int(rgb.split(" ")[2])]
	return liste

def list_to_rgb(liste):
	rgb=str(liste[0])+' '+str(liste[1])+' '+str(liste[2])
	return rgb

def list_to_rgb_P6(liste):
	rgb=str(liste[0])+str(liste[1])+str(liste[2])
	return rgb

def pixel_to_rgb(pix):
	rgb=str(pix).split(" ")[1]
	rgb=rgb.split("}")[0]
	rgb=rgb.replace(","," ")
	liste=rgb_to_list(rgb)
	rgb=list_to_rgb_P6([chr(liste[0]),chr(liste[1]),chr(liste[2])])
	return rgb

##################################################################################################
#######  FONCTIONS DE RETOUCHE

def sepia(color):
	color_list=rgb_to_list(color)
	rouge=trunc(int(color_list[0])*0.393+int(color_list[1])*0.769+int(color_list[2])*0.189)
	vert=trunc(int(color_list[0])*0.349+int(color_list[1])*0.686+int(color_list[2])*0.168)
	bleu=trunc(int(color_list[0])*0.272+int(color_list[1])*0.534+int(color_list[2])*0.131)
	color_list=[rouge,vert,bleu]
	return list_to_rgb(color_list)

def black_white(color):
	color_list=rgb_to_list(color)
	color=trunc((int(color_list[0])+int(color_list[1])+int(color_list[2]))/3)
	color_list=[color,color,color]
	return list_to_rgb(color_list)

def negatif(color):
	color_list=rgb_to_list(color)
	color_list=[255-int(color_list[0]),255-int(color_list[1]),255-int(color_list[2])]
	return list_to_rgb(color_list)

def old_to_new(old, new, color):
	for case in table:
		if case[0]==old:
			old=case[1]
		if case[0]==new:
			new=case[1]
	old_list=rgb_to_list(old)
	color_list=rgb_to_list(color)
	distance=sqrt(pow(int(old_list[0]) - int(color_list[0]),2)+pow(int(old_list[1]) - int(color_list[1]),2)+pow(int(old_list[2]) - int(color_list[2]),2))
	if distance<=200:
		return new
	else:
		return color

###################################################################################################
#######  FONCTION D'ENREGISTREMENT DU FICHIER

def save_image(image, fichier):
	texte=""
	f=open(fichier, 'w')
	f.write('P6\n'+str(image.width)+' '+str(image.height)+' '+str(image.depth)+'\n')
	for i in image.pixels:
		rgb=pixel_to_rgb(i)
		f.write(rgb+'\n')
	f.close()

###################################################################################################
#######  DEBUT DU PROGRAMME

img=read_image(arguments[0])
save_image(img, arguments[1])
